<?

function vd(&$var)
{
    ob_start();
    var_dump($var);
    $cnt=ob_get_contents();
    ob_end_clean();
    return nl2br(str_replace(' ','&nbsp;&nbsp;&nbsp;&nbsp;',htmlspecialchars($cnt)));
}



class connector
{
    protected $curl_handler = null;
    protected $url = '';
    protected $request_data = array();

    public function __construct($url)
    {
        $this->curl_handler = @curl_init();
        $this->url = $url;
        
        if(is_resource($this->curl_handler) && is_string($this->url) && !empty($this->url))
        {
            curl_setopt($this->curl_handler, CURLOPT_URL, $this->url);
            curl_setopt($this->curl_handler, CURLOPT_FRESH_CONNECT, true); // 
            curl_setopt($this->curl_handler, CURLOPT_POST, true); //  
            curl_setopt($this->curl_handler, CURLOPT_RETURNTRANSFER, true); //         
        }
        else
        {
            return false;
        }
    }
    
    public function __destruct()
    {
        @curl_close($this->curl_handler);
        return;
    }
    
    public function execute()
    {
        curl_setopt($this->curl_handler, CURLOPT_POSTFIELDS, array('api_request'=>$this->request_data)); //   
        return curl_exec($this->curl_handler); 
    }
}


class connector_dogbody extends connector
{
    protected $response_data = null;
    
    public function __construct($url)
    {
        parent::__construct($url);
    }
    
    
    public function request($arr)
    {
        if(is_array($arr) && !empty($arr) && isset($arr['f_name']) && isset($arr['args']))
        {
            $this->request_data = $this->prepare($arr);
            
            $this->response_data = $this->execute();
            
            return $this->get_response();
        }
        else
        {
            return false;
        }
    }
    
    protected function prepare($arr)
    {
        return urlencode(serialize($arr));
    }
    
    protected function get_response()
    {
        return unserialize(urldecode($this->response_data));
    }
}


$c = new connector_dogbody('http://my_api_provider.com/api_test.php');

$res = $c->request(array('f_name'=>'get_users', 'args'=>array('void'=>'')));


echo vd($res); 
exit;












